from StringIO import StringIO

import bson
import gpgme
import ctypes 
libgpgme = ctypes.cdll.LoadLibrary('libgpgme.so.11') 
libgpgme.gpgme_check_version.restype = ctypes.c_char_p 
libgpgme.gpgme_check_version(None) 
import web

class verify:
    def GET(self):
        return (
                "POST to this URL to verify a signature. "
                "The result will be a bson format dict with three keys: "
                "timestamp, signed-content and signer (a key fingerprint). "
                "Errors result in a 500 HTTP status code with body describing "
                "the fault."
                )

    def POST(self):
        try:
            context = gpgme.Context()
        except gpgme.GpgmeError, e:
            raise web.webapi.internalerror(e.message)
        signed = StringIO(web.data())
        plaintext = StringIO()
        try:
            signatures = context.verify(signed, None, plaintext)
        except gpgme.GpgmeError, e:
            raise web.webapi.internalerror(e.message)
        if len(signatures) != 1:
            raise web.webapi.internalerror(
                    "Either no signatures, or too many.")
        if signatures[0].status is not None:
            raise web.webapi.internalerror(str(signatures[0].status.args))
        result = {
            'timestamp': signatures[0].timestamp,
            'signed-content': plaintext.getvalue(),
            'signer': signatures[0].fpr,
            }
        return bson.dumps(result)

urls = (
  '/', 'verify',
  )

app = web.application(urls, globals(), autoreload=False)
if __name__ == "__main__":
    web.config.debug = False
    app.run()
